/*
  cxproc - Configurable Xml PROCessor

  Copyright (C) 2006,2007,2008 by Alexander Tenbusch

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License 
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/* 
   access to element names
*/

/* 
   definition of element names (s. cxp.dtd)
*/

#define NAME_MAKE BAD_CAST "make"

#define NAME_META BAD_CAST "meta"

#define NAME_THREAD BAD_CAST "thread"

#define NAME_FROM BAD_CAST "from"

#define NAME_EACH BAD_CAST "each"

#define NAME_XML BAD_CAST "xml"

#define NAME_XSL BAD_CAST "xsl"

#define NAME_SQL BAD_CAST "sql"

#define NAME_VARIABLE BAD_CAST "variable"

#define NAME_PIE BAD_CAST "pie"

#define NAME_PLAIN BAD_CAST "plain"

#define NAME_IMAGE BAD_CAST "image"

#define NAME_XHTML BAD_CAST "xhtml"

#define NAME_SYSTEM BAD_CAST "system"

#define NAME_SUBST BAD_CAST "subst"

#define NAME_FILECOPY BAD_CAST "copy"

#define NAME_INFO BAD_CAST "info"

#define NAME_ENV BAD_CAST "env"


#define NAME_CALENDAR BAD_CAST "calendar"

#define NAME_COL BAD_CAST "col"


#define NAME_DIR BAD_CAST "dir"

#define NAME_FILE BAD_CAST "file"


#define NAME_PATHNET BAD_CAST "pathnet"

#define NAME_PATHTABLE BAD_CAST "pathtable"


/* 
   comparison of element names
*/

#define IS_NODE(NODE,NAME) (NODE != NULL && NODE->type == XML_ELEMENT_NODE && (NAME==NULL || xmlStrEqual(NODE->name,NAME)))


#define IS_NODE_MAKE(NODE) (IS_NODE(NODE,NAME_MAKE))

#define IS_NODE_META(NODE) (IS_NODE(NODE,NAME_META))

#define IS_NODE_THREAD(NODE) (IS_NODE(NODE,NAME_THREAD))

#define IS_NODE_FROM(NODE) (IS_NODE(NODE,NAME_FROM))

#define IS_NODE_EACH(NODE) (IS_NODE(NODE,NAME_EACH))

#define IS_NODE_XML(NODE) (IS_NODE(NODE,NAME_XML))

#define IS_NODE_XSL(NODE) (IS_NODE(NODE,NAME_XSL))

#define IS_NODE_VARIABLE(NODE) (IS_NODE(NODE,NAME_VARIABLE))

#define IS_NODE_PIE(NODE) (IS_NODE(NODE,NAME_PIE))

#define IS_NODE_PLAIN(NODE) (IS_NODE(NODE,NAME_PLAIN))

#define IS_NODE_IMAGE(NODE) (IS_NODE(NODE,NAME_IMAGE))

#define IS_NODE_XHTML(NODE) (IS_NODE(NODE,NAME_XHTML))

#define IS_NODE_SYSTEM(NODE) (IS_NODE(NODE,NAME_SYSTEM))

#define IS_NODE_SUBST(NODE) (IS_NODE(NODE,NAME_SUBST))

#define IS_NODE_MESSAGE(NODE) (IS_NODE(NODE,NAME_MESSAGE))


#define IS_NODE_CALENDAR(NODE) (IS_NODE(NODE,NAME_CALENDAR))

#define IS_NODE_COL(NODE) (IS_NODE(NODE,NAME_COL))


#define IS_NODE_DIR(NODE) (IS_NODE(NODE,NAME_DIR))

#define IS_NODE_FILE(NODE) (IS_NODE(NODE,NAME_FILE))


#define IS_NODE_PATHNET(NODE) (IS_NODE(NODE,NAME_PATHNET))

#define IS_NODE_PATHTABLE(NODE) (IS_NODE(NODE,NAME_PATHTABLE))

#define IS_NODE_FILECOPY(NODE) (IS_NODE(NODE,NAME_FILECOPY))

