/*
  cxproc - Configurable Xml PROCessor

  Copyright (C) 2006,2007,2008 by Alexander Tenbusch

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License 
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/


/*! global iconv conversion descriptors
 */

typedef struct {

    iconv_t env;    /*! charset environment */
    iconv_t cgi;    /*! charset CGI */
    iconv_t argv;   /*! charset command line arguments */
    iconv_t fs;     /*! charset filesystem informations */
    iconv_t plain;  /*! charset plain text file content */

} cd_direction_t;

typedef struct {

  cd_direction_t from;

  cd_direction_t to;

} cd_collection_t;

extern cd_collection_t cd;


extern BOOL_T
set_encodingsUTF8(xmlChar *id_env, xmlChar *id_cgi, xmlChar *id_argv, xmlChar *id_fs, xmlChar *id_plain);

xmlChar *
getargvUTF8(const int int_argv);

extern xmlChar *
getenvUTF8(const xmlChar *ptr_name);

extern xmlChar *
getcgiUTF8(const xmlChar *ptr_name);

extern void
free_iconv(void);

extern xmlChar *
getcwdUTF8(void);

#define  dir_is_readableUTF8(PATH) type_is_readableUTF8(PATH,TRUE,NULL)

#define file_is_readableUTF8(PATH) type_is_readableUTF8(PATH,FALSE,NULL)

#define    file_size_UTF8(PATH,PS) type_is_readableUTF8(PATH,FALSE,PS)

extern BOOL_T
type_is_readableUTF8(const xmlChar *ptr_path, const BOOL_T flag_dir, long int *ptr_size);

extern BOOL_T
file_copyUTF8(xmlNodePtr n);

extern BOOL_T
mkdir_pathUTF8(const xmlChar *ptr_path, const int mode);

extern BOOL_T
test_and_viewUTF8(xmlNodePtr n);

extern xmlChar *
fgetparUTF8(int *mode, int *mode_type, int size, FILE *stream);

extern xmlChar *
fgetUTF8(xmlChar *file_name);

extern BOOL_T
iconv_error(int int_errno, size_t nconv);

#ifdef TESTCODE
extern int
test_module_iconv(void);
#endif
